
// Disable "identifier was truncated to '255' characters in the debug information" warning.
#pragma warning(disable: 4786)

#include <iostream>
#include <fstream>
#include <string>
using namespace std;

#include "delegate.h"


class App
{
public:
    //   Callback,
    //   1     .
    typedef CDelegate1<void, string> Callback;

    //    App.
    void OutputToConsole(string str)
    {
        cout << str << endl;
    }

    //      App.
    static void OutputToFile(string str)
    {
        ofstream fout("output.txt", ios::out | ios::app);
        fout << str << endl;
        fout.close();
    }
};

int main()
{
    App app;

    //  .
    App::Callback callback = NULL;
    if(!callback.IsNull()) callback("1");

    //    OutputToFile.
    //    .
    callback += NewDelegate(App::OutputToFile);
    if(!callback.IsNull()) callback("2");

    //    OutputToConsole.
    //   :
    //  OutputToFile,  OutputToConsole.
    callback += NewDelegate(&app, &App::OutputToConsole);
    if(!callback.IsNull()) callback("3");

    //    OutputToFile.
    //   OutputToConsole.
    callback -= NewDelegate(App::OutputToFile);
    if(!callback.IsNull()) callback("4");

    //     OutputToConsole.
    callback -= NewDelegate(&app, &App::OutputToConsole);
    if(!callback.IsNull()) callback("5");

	return 0;
}